#pragma once
#include "Entity.h"
#include "EntityStateGravity.h"
#include "EntityStateSplash.h"
#define CS_ENEMY_ROLLROCK_CREATENAME L"CS_enemy_rollrock"
//Âä¹öÊ¯£¨Å×ÉäÎï£©
class CS_Enemy_RollRock :
    public Entity
{
public:
    CS_Enemy_RollRock();
    void Init(std::weak_ptr<Entity> self) override;
    void Step() override;
    void SetState(int stateID, int lr) override;
    void Attack(std::weak_ptr<Entity> dst, int* outDamage, float* outAngle, bool* outTakedown, int* outElemType, float* outShockForce, float* outHeavy) override;
    void AttackEffectObject(std::weak_ptr<Entity> target, float centerX, float centerY, int realDamage) override;
    bool Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage) override;
    EntityStateGravity stateGravity;
    EntityStateSplash stateSplash;
    float slopeLow_cos60 = 0;
    float slopeHigh_cos45 = 0;
    float lastHSpeed = 0;
    int attack_interval_max = 0;
    int attack_interval = 0;
};

std::shared_ptr<Entity> CreateCS_Enemy_RollRock();